/*
 ******************************************************************************************
 * @file      main.c
 * @author    GowinSemicoductor
 * @device    Gowin_EMPU_M1
 * @brief     Main function.
 ******************************************************************************************
 */

/* Includes ------------------------------------------------------------------*/
#include "uart.h"
#include "multiple.h"
#include <stdio.h>


/* Definitions ---------------------------------------------------------------*/
int main(void)
{
	SystemInit();		//Initializes system
	UartInit();			//Initializes UART0
	
	printf("\r\nIt is an AHB Arbiter demo.\r\n\r\n");
	
	printf("Initializes system...\r\n");
	printf("Initializes UART0...\r\n");
	printf("Initializes multiplication...\r\n");
	printf("\r\nInitialized status : \r\n");
	printf("Multiplier = %d\r\n",getMultiplier());
	printf("Multiplicand = %d\r\n",getMultiplicand());
	printf("Cmd = %d\r\n",getMultipleCmd());
	printf("Result = %d\r\n",getMultipleResult());
  
	printf("\r\n- - - - - - - - - - - - - - - - -\r\n\r\n");
	
	printf("First multiplication...\r\n");
	setMultiplier(20);
	setMultiplicand(40);
	startMultiple();
	printf("\r\nComputing status : \r\n");
	printf("Multiplier = %d\r\n",getMultiplier());
	printf("Multiplicand = %d\r\n",getMultiplicand());
	printf("Cmd = %d\r\n",getMultipleCmd());
	
	while(getFinishStatus()==FINISHED_STATUS);
	finishMultiple();
	
	printf("\r\nFinished status : \r\n");
	printf("Multiplier = %d\r\n",getMultiplier());
	printf("Multiplicand = %d\r\n",getMultiplicand());
	printf("Cmd = %d\r\n",getMultipleCmd());
	printf("Result = %d\r\n",getMultipleResult());

	printf("\r\n- - - - - - - - - - - - - - - - -\r\n\r\n");
	
	printf("Second multiplication...\r\n");
	setMultiplier(30);
	setMultiplicand(50);
	startMultiple();
	printf("\r\nComputing status : \r\n");
	printf("Multiplier = %d\r\n",getMultiplier());
	printf("Multiplicand = %d\r\n",getMultiplicand());
	printf("Cmd = %d\r\n",getMultipleCmd());
	
	while(getFinishStatus()==FINISHED_STATUS);
	finishMultiple();
	
	printf("\r\nFinished status : \r\n");
	printf("Multiplier = %d\r\n",getMultiplier());
	printf("Multiplicand = %d\r\n",getMultiplicand());
	printf("Cmd = %d\r\n",getMultipleCmd());
	printf("Result = %d\r\n",getMultipleResult());
	
	printf("\r\n- - - - - - - - - - - - - - - - -\r\n\r\n");
	
	while(1);

	return 0;
}
